io.vertx.grpc.server

## Interface GrpcServerResponse<Req,Resp>

- All Superinterfaces:
    GrpcWriteStream<Resp>, StreamBase, WriteStream<Resp>

      public interface GrpcServerResponse<Req,Resp>
      extends GrpcWriteStream<Resp>

- - ### Method Summary

    All Methods Instance Methods Abstract Methods Default Methods
    Modifier and Type | Method and Description
    --- | ---
    `GrpcServerResponse<Req,Resp>` | `drainHandler(Handler<Void> handler)` Set a drain handler on the stream.
    `GrpcServerResponse<Req,Resp>` | `encoding(String encoding)` Set the stream encoding, e.g `identity` or `gzip`.
    `GrpcServerResponse<Req,Resp>` | `exceptionHandler(Handler<Throwable> handler)` Set an exception handler on the write stream.
    `default Future<Void>` | `send(ReadStream<Resp> body)`
    `default Future<Void>` | `send(Resp item)`
    `GrpcServerResponse<Req,Resp>` | `setWriteQueueMaxSize(int maxSize)` Set the maximum size of the write queue to `maxSize`.
    `GrpcServerResponse<Req,Resp>` | `status(GrpcStatus status)` Set the grpc status response
    `GrpcServerResponse<Req,Resp>` | `statusMessage(String msg)` Set the grpc status response message
    `MultiMap` | `trailers()`

    - ### Methods inherited from interface io.vertx.grpc.common.GrpcWriteStream

      `cancel, endMessage, headers, writeMessage`

    - ### Methods inherited from interface io.vertx.core.streams.WriteStream

      `end, end, end, end, write, write, writeQueueFull`

- - ### Method Detail

    - #### status

          GrpcServerResponse<Req,Resp> status(GrpcStatus status)

      Set the grpc status response
      Parameters:
        `status` - the status
      Returns:
        a reference to this, so the API can be used fluently

    - #### statusMessage

          GrpcServerResponse<Req,Resp> statusMessage(String msg)

      Set the grpc status response message
      Parameters:
        `msg` - the message
      Returns:
        a reference to this, so the API can be used fluently

    - #### encoding

          GrpcServerResponse<Req,Resp> encoding(String encoding)

      Description copied from interface: `GrpcWriteStream`
      Set the stream encoding, e.g `identity` or `gzip`. It must be called before sending any message, otherwise {@code identity will be used.
      Specified by:
        `encoding` in interface `GrpcWriteStream<Resp>`
      Parameters:
        `encoding` - the target message encoding
      Returns:
        a reference to this, so the API can be used fluently

    - #### trailers

          MultiMap trailers()

      Returns:
        the `MultiMap` to write metadata trailers

    - #### exceptionHandler

          GrpcServerResponse<Req,Resp> exceptionHandler(Handler<Throwable> handler)

      Description copied from interface: `WriteStream`
      Set an exception handler on the write stream.
      Specified by:
        `exceptionHandler` in interface `GrpcWriteStream<Resp>`
      Specified by:
        `exceptionHandler` in interface `StreamBase`
      Specified by:
        `exceptionHandler` in interface `WriteStream<Resp>`
      Parameters:
        `handler` - the exception handler
      Returns:
        a reference to this, so the API can be used fluently

    - #### setWriteQueueMaxSize

          GrpcServerResponse<Req,Resp> setWriteQueueMaxSize(int maxSize)

      Description copied from interface: `WriteStream`
      Set the maximum size of the write queue to `maxSize`. You will still be able to write to the stream even if there is more than `maxSize` items in the write queue. This is used as an indicator by classes such as `Pipe` to provide flow control.

      The value is defined by the implementation of the stream, e.g in bytes for a `NetSocket`, etc...
      Specified by:
        `setWriteQueueMaxSize` in interface `GrpcWriteStream<Resp>`
      Specified by:
        `setWriteQueueMaxSize` in interface `WriteStream<Resp>`
      Parameters:
        `maxSize` - the max size of the write stream
      Returns:
        a reference to this, so the API can be used fluently

    - #### drainHandler

          GrpcServerResponse<Req,Resp> drainHandler(Handler<Void> handler)

      Description copied from interface: `WriteStream`
      Set a drain handler on the stream. If the write queue is full, then the handler will be called when the write queue is ready to accept buffers again. See `Pipe` for an example of this being used.

      The stream implementation defines when the drain handler, for example it could be when the queue size has been reduced to `maxSize / 2`.

      Specified by:
        `drainHandler` in interface `GrpcWriteStream<Resp>`
      Specified by:
        `drainHandler` in interface `WriteStream<Resp>`
      Parameters:
        `handler` - the handler
      Returns:
        a reference to this, so the API can be used fluently

    - #### send

          default Future<Void> send(Resp item)

    - #### send

          default Future<Void> send(ReadStream<Resp> body)

Copyright © 2025 Eclipse. All rights reserved.